(*Ŀ
  Source                                                                  
                                                                  
                                                                            
    Les sources des plasmas sont incrites dans un cadre dans chaque         
 procdure nomme 'Plasma_'                                                 
Ĵ
  Info                                                                    
                                                                    
                                                                            
  Diffrents effets de plasma dans le mode 320x200 pixels en 256 couleurs   
*)

{$M 2048,0,64000}

{$G+ :Utilise les fonctions du 286 : SHL & SHR (multiplication ultra rapide) }
{$R-}
{$Q-}

{-$DEFINE Fps}      { Affiche le nombre d'images par secondes }

Uses Clavier,EcranVga,PalVideo {$IFDEF Fps} ,Fps {$ENDIF};

const
  ZoomPlasma4 = 1.0;

Var
  TableX : array[0..319] of byte;
  TableY : array[0..199] of byte;
  TableSin: Array[0..255] of Byte;
  TableCos: Array[0..255] of Byte;

  ix,vram,index: Word;

  i: word;
  Coul: Byte;
  X1,X2,SauveX1,SauveX2,
  Y1,Y2,SauveY1,SauveY2 ,iy: Byte;

  SavPalette,Palette : Array[0..255] of RVB;

  TamponEcran: PtrImage;

procedure RotationPalette; var R,V,B: byte; begin
  { Rotation dans le sens positif }
  repeat
    R := Palette[255].R; V := Palette[255].V; B := Palette[255].B;
    move (Palette[0],Palette[1],255*3);
    Palette[0].R := R; Palette[0].V := V; Palette[0].B := B;

    AttendEcran;
    ChangeGrandePal (Palette,0,256);
  until TouchPresse;
  LitTouche;
end;

procedure TransitionEntrePlasma; begin
  { Fondu vers le noir }
  LitGrandePal (SavPalette,0,256);
  i := 0;
  repeat
    for Coul := 0 to 255 do with SavPalette[Coul] do begin
      if 0<R then dec(R);
      if 0<V then dec(V);
      if 0<B then dec(B);
    end;
    AttendEcran;
    ChangeGrandePal (SavPalette,0,256);
    inc (i);
  until i=63;

  { Affiche le nouveau plasma }
  AfficheEcran;

  { Fondu vers la couleur (clair) }
  LitGrandePal (SavPalette,0,256);
  i := 0;
  repeat
    for Coul := 0 to 255 do begin
      with SavPalette[Coul] do begin
        if R<Palette[Coul].R then inc(R);
        if V<Palette[Coul].V then inc(V);
        if B<Palette[Coul].B then inc(B);
      end;
    end;
    AttendEcran;
    ChangeGrandePal (SavPalette,0,256);

    inc (i);
  until i=63;
end;

Procedure Plasma1; Begin
{      Ŀ      }
{      Code : RaPhiUS / ANubiS               }
{ =  henrraph@skynet.be                = }
{      http://users.skynet.be/henrraph/      }
{            }

  { Prcalcul }
  for i := 0 to 255 do TableCos[i] := Round(30*(cos(i*pi/64)));

  { Cre la palette }
  For i:=0 to 63 do Begin
    { Rose -> Jaune }
    with Palette[i    ] do begin R := 63;   V := i;  B := 63-i end;

    { Jaune -> Cyan }
    with Palette[i +64] do begin R := 63-i; V := 63;   B := i    end;

    { Cyan -> Bleu }
    with Palette[i+128] do begin R := 0;    V := 63-i; B := 63   end;

    { Bleu -> Rose }
    with Palette[i+192] do begin R := i;    V := 0;    B := 63   end;
  End;
  ChangeGrandePal (Palette,0,256);
  {$IFDEF Fps} ReinitFps; {$ENDIF}

  { Dessin du plasma }
  repeat
    X1 := SauveX1;
    X2 := SauveX2;

    {$IFNDEF Fps} AttendEcran; {$ENDIF}

    vram := 0;
    for iy := 0 to 199 do begin
      Y1 := SauveY1;
      Y2 := SauveY2;

      for ix := 0 to 319 do begin
        Ecran^[Vram] := TableCos[X1]+TableCos[X2]+TableCos[Y1]+TableCos[Y2];

        inc (vram);
        inc(Y1,3);
        inc(Y2,1);
      end;

      inc(X1,2);
      inc(X2,1);
    end;

    inc (SauveX1,1);
    inc (SauveX2,2);
    inc (SauveY1,3);
    inc (SauveY2,4);

    {$IFDEF Fps} ActuFps; {$ENDIF}
  until TouchPresse;
  LitTouche;
End;

procedure Plasma2; var PosY,PosX,iy: byte; DecalY: Word; begin

(*
  Nice Looking Plasma With TP Code (1996)
  By Darius Sutherland / Eddie Hattie - GenetiX
           ^^^^^^^^^^^   ^^^^^
           The DarkMan / Gedge

  101616.3646.compuserve.com

  Seeya On the other Side...... DJ D The DarkMan
*)

  { Prcalcul }
  for i := 0 to 255 do TableSin[i] := Round(sin(PI*2*i/256)*128);
  for i := 0 to 127 do TableCos[i] := Round(cos(PI*2*i/256)*128);

  { Cre la palette }
  For i := 0 To 127 Do begin
    iy := i shr 1;
    with Palette[i    ] do begin R := iy; V := 0; B := 0 end;
    iy := 63-iy;
    with Palette[i+128] do begin R := iy; V := 0; B := 0 end;
  end;
  ChangeGrandePal (Palette,0,256);
  {$IFDEF Fps} ReinitFps; {$ENDIF}

  { Dessin du plasma (temps rel) }
  Repeat
    DecalY := TableCos [PosY and 127];

    {$IFNDEF Fps} AttendEcran; {$ENDIF}
    vram := 0;
    For iy := 0 To 199 do for ix:= 0 to 319 do begin
      Ecran^[Vram] := TableSin[ (ix+TableSin[(ix+PosX) and 255]) and 255]
                     +TableCos[ (iy+DecalY)                      and 127];
      inc (vram);
    end;

    {$IFDEF Fps} ActuFps; {$ENDIF}

    Inc(PosX,3); inc(PosY,2);
  Until TouchPresse;
  LitTouche;
end;

procedure Plasma3; var CosY,CosDecal,Decal: byte; begin

(*
  Coded by Sir [HS] of BiokilL
  E-Mail: h0sieber@rks.harz.ni.schule.de
  BiokilL Demogroup WWW-Homepage:
  http://www.rks.harz.ni.schule.de/~t0quetsc/BKL.html
*)

  { Prcalcul }
  for ix := 0 to 255 do begin
    TableCos [ix] := Round(cos(2*pi*ix/255)*128)+128;
    TableSin [ix] := Round(sin(2*pi*ix/255)*128)+128;
  end;

  iy := 0; Decal := 0;

  { Cre la palette }
  For i := 0 to 127 do Begin
    ix := i shr 1;
    with Palette[i    ] do begin R :=  0; V :=  0; B := ix end;
    ix := 63-ix;
    with Palette[i+128] do begin R :=  0; V :=  0; B := ix end;
  End; ChangeGrandePal (Palette,0,256);
  {$IFDEF Fps} ReinitFps; {$ENDIF}

  { Dessin du plasma (temps rel) }
  repeat
    vram := 0;
    for iy := 0 to 199 do begin
      CosY     := TableCos [(iy+iy) and 255];
      CosDecal := TableCos [decal];

      for ix := 0 to 319 do begin
        Ecran^[Vram] := TableCos[(ix+CosY) and 255] +TableSin[(iy+CosDecal) and 255];
        inc (vram);
      end;
    end;

    {$IFDEF Fps} ActuFps; {$ENDIF}

   { dec (iy,2); inc (decal,2);  ---> Plus rapide }
    dec (iy); inc (decal);
  until TouchPresse;
  LitTouche;
end;

procedure Plasma4; const zoom = 128; { min=16; cool=256; max=8192 } begin
{      Ŀ      }
{                                             }
{ =  Je n'ai pas incrit la source  :-<  = }
{                                             }
{            }

  { Prcalcul }
  for i := 0 to 319 do TableX[i] := Round(cos(pi*i/160)*zoom);
  for i := 0 to 199 do TableY[i] := Round(cos(pi*i/100)*zoom);

  { Cre la palette }
  for i := 0 to 63 do begin
    { Jaune -> Rouge }
    with palette[i    ] do begin R := 63;   V := 63-i; B := 0    end;

    { Rouge -> Vert }
    with palette[i +64] do begin R := 63-i; V := i;    B := 0    end;

    { Vert -> Bleu }
    with palette[i+128] do begin R := 0;    V := 63-i; B := i    end;

    { Bleu -> Jaune }
    with palette[i+192] do begin R := i;    V :=  i;   B := 63-i end;
  end;

  { Dessin du plasma }
  vram := 0;
  for iy := 0 to 199 do
    for ix := 0 to 319 do begin
      TamponEcran^[vram] := TableX[ix]+TableY[iy];
      inc (vram);
    end;
end;

procedure Plasma5; const Diametre = 4; begin
{      Ŀ      }
{                                             }
{ =  Je n'ai pas incrit la source  :-<  = }
{                                             }
{            }

  { Cre la palette }
  for i := 0 to 127 do begin
    Coul := i shr 1;
    with Palette[i    ] do begin R := 0; V := Coul; B := Coul end;
    Coul := 63-Coul;
    with Palette[i+128] do begin R := 0; V := Coul; B := Coul end;
  end;

  { Dessine le plasma }
  vram := 0;
  for iy := 0 to 199 do begin
    index := iy*iy;
    for ix := 0 to 319 do begin
      TamponEcran^[vram] := (ix*ix +index) shr diametre;
      inc (vram);
    end;
  end;
end;

procedure PutPixel (X,Y: Word; Coul: Byte); begin
  TamponEcran^[Y shl 8 +Y shl 6 +X] := Coul;
end;

function GetPixel (X,Y: Word) : byte; begin
  GetPixel := TamponEcran^[Y shl 8 +Y shl 6 +X];
end;

procedure adjust (xa,ya,x,y,xb,yb: integer);
var
  d: integer;
  v: real;
begin
  if GetPixel(x,y)<>0 then exit;

  D := Abs(xa-xb)+Abs(ya-yb);
  V := (GetPixel(xa,ya)+GetPixel(xb,yb))/2+(random-0.5)*d*ZoomPlasma4;
  if v<1 then v:=1;
  if v>=255 then v := 255; { 255 couleurs maximum }

  PutPixel(x,y,Round(V));
end;

procedure subDivide (Xorigine,Yorigine,Larg,Haut: integer);
var
  Xcentre,Ycentre: integer;
  v: real;
begin
  if (Larg-Xorigine<2) and (Haut-Yorigine<2) then exit;

  Xcentre := (Xorigine+Larg) shr 1;
  Ycentre := (Yorigine+Haut) shr 1;

  adjust (Xorigine,Yorigine,  Xcentre, Yorigine,  Larg,    Yorigine);
  adjust (Larg,    Yorigine,  Larg,    Ycentre,   Larg,    Haut);
  adjust (Xorigine,Haut,      Xcentre, Haut,      Larg,    Haut);
  adjust (Xorigine,Yorigine,  Xorigine,Ycentre,   Xorigine,Haut);

  if GetPixel(Xcentre,Ycentre)=0 then
    PutPixel(
    Xcentre,
    Ycentre,
    (
     GetPixel (Xorigine,Yorigine)+
     GetPixel (Larg,Yorigine)+
     GetPixel (Larg,Haut)+
     GetPixel (Xorigine,Haut)
    ) shr 2);

  subDivide(Xorigine,Yorigine,Xcentre,Ycentre);
  subDivide(Xcentre,Yorigine,Larg,Ycentre);
  subDivide(Xcentre,Ycentre,Larg,Haut);
  subDivide(Xorigine,Ycentre,Xcentre,Haut);
end; { procedure subDivide }

procedure Plasma6; begin

{      Ŀ      }
{               Downloaded from               }
{ =       Sigma Networks (Europe)       = }
{         Turbo Pascal Archives .....         }
{            }

  { Cre la palette }
  for i := 0 to 63 do begin
    { Jaune -> Rouge }
    with Palette[i    ] do begin R := 63;   V := 63-i; B := 0    end;

    { Rouge -> Vert }
    with Palette[i +64] do begin R := 63-i; V := i;    B := 0    end;

    { Vert -> Bleu }
    with Palette[i+128] do begin R := 0;    V := 63-i; B := i    end;

    { Bleu -> Jaune }
    with Palette[i+192] do begin R := i;    V :=  i;   B := 63-i end;
  end;

  { Dessine le plasma }
  Randomize;

  EffacePtr (TamponEcran,0);
  TamponEcran^[  0*320 +0  ] := 1+Random(192);
  TamponEcran^[  0*320 +319] := 1+Random(192);
  TamponEcran^[199*320 +0  ] := 1+Random(192);
  TamponEcran^[199*320 +319] := 1+Random(192);

  subDivide(0,0,319,199);
end;

Begin
  GetMem (TamponEcran,64000);
  ModeVga256;

  {$IFDEF Fps} InitFps (320-14*8,192,5,TRUE); {$ENDIF}
  Plasma1;
  Plasma2;
  Plasma3;
  {$IFDEF Fps} FinFps; {$ENDIF}
  ChangeDestEcran (TamponEcran);
  Plasma4; TransitionEntrePlasma; RotationPalette;
  Plasma5; TransitionEntrePlasma; RotationPalette;
  Plasma6; TransitionEntrePlasma; RotationPalette;

  ModeTxt;
  Dispose (TamponEcran);
End.

